<template>
    <form v-on:submit.prevent="submit()">
        <div class="form-group row">
            <div class="col-md-6">
                <input type="text"
                       class="form-control"
                       placeholder="First Name"
                       name="firstName"
                       required
                       v-model="newAddress.firstName"
                       v-validate.initial="'required'"
                       v-bind:class="{
                           'input--invalid': errors.has('firstName') && fields.firstName.touched,
                           'input--valid': fields.firstName && fields.firstName.dirty && !errors.has('firstName')
                       }"
                />
                <div v-show="errors.has('firstName') && fields.firstName.touched"
                     class="alert alert-danger"
                >
                    <div>
                        First Name is required
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <input type="text"
                       class="form-control"
                       placeholder="Last Name"
                       name="lastName"
                       required
                       v-model="newAddress.lastName"
                       v-validate.initial="'required'"
                       v-bind:class="{
                           'input--invalid': errors.has('lastName') && fields.lastName.touched,
                           'input--valid': fields.lastName && fields.lastName.dirty && !errors.has('lastName')
                       }"
                />
                <div v-show="errors.has('lastName') && fields.lastName.touched"
                     class="alert alert-danger"
                >
                    <div>
                        Last Name is required
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group row">
            <div class="col-md-12">
                <input type="text"
                       class="form-control"
                       placeholder="Address Line"
                       name="addressLine"
                       required
                       v-model="newAddress.addressLine"
                       v-validate.initial="'required'"
                       v-bind:class="{
                           'input--invalid': errors.has('addressLine') && fields.addressLine.touched,
                           'input--valid': fields.addressLine && fields.addressLine.dirty && !errors.has('addressLine')
                       }"
                />
                <div v-show="errors.has('addressLine') && fields.addressLine.touched"
                     class="alert alert-danger"
                >
                    <div>
                        Address Line is required
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group row">
            <div class="col-md-6">
                <input type="text"
                       class="form-control"
                       placeholder="City"
                       name="city"
                       required
                       v-model="newAddress.city"
                       v-validate.initial="'required'"
                       v-bind:class="{
                           'input--invalid': errors.has('city') && fields.city.touched,
                           'input--valid': fields.city && fields.city.dirty && !errors.has('city')
                       }"
                />
                <div v-show="errors.has('city') && fields.city.touched"
                     class="alert alert-danger"
                >
                    <div>
                        City is required
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <input type="text"
                       class="form-control"
                       placeholder="Postcode"
                       name="postCode"
                       required
                       v-model="newAddress.postCode"
                       v-validate.initial="'required'"
                       v-bind:class="{
                           'input--invalid': errors.has('postCode') && fields.postCode.touched,
                           'input--valid': fields.postCode && fields.postCode.dirty && !errors.has('postCode')
                       }"
                />
                <div v-show="errors.has('postCode') && fields.postCode.touched"
                     class="alert alert-danger"
                >
                    <div>
                        Post Code is required
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group row">
            <div class="col-md-10">
                <input type="text"
                       class="form-control"
                       placeholder="State"
                       name="state"
                       required
                       v-model="newAddress.state"
                       v-validate.initial="'required'"
                       v-bind:class="{
                           'input--invalid': errors.has('state') && fields.state.touched,
                           'input--valid': fields.state && fields.state.dirty && !errors.has('state')
                       }"
                />
                <div v-show="errors.has('state') && fields.state.touched"
                     class="alert alert-danger"
                >
                    <div>
                        State is required
                    </div>
                </div>
            </div>
            <div class="col-md-2">
                <button type="submit"
                        class="btn btn-success pull-right"
                        :disabled="errors.any()"
                >Add Address
                </button>
            </div>
        </div>
    </form>
</template>

<script>

    import AddressService from '../services/AddressService.js';

    let addressService = new AddressService();

    export default {
        data() {
            return {
                newAddress: {}
            }
        },
        methods: {
            submit() {
                this.$emit('onCreateAddress', this.newAddress)
            }
        }
    }
</script>

<style>
    input.form-control {
        border-left: 5px solid #cccccc; /* red */
    }

    input.form-control.input--valid {
        border-left: 5px solid #42a948; /* green */
    }

    input.form-control.input--invalid {
        border-left: 5px solid #a94442; /* red */
    }
</style>